|  | Home · All Classes · Modules

# QRunnable Class Reference
[QtCore module]

The QRunnable class is the base class for all runnable objects. More...

### Methods

- __init__ (self)
- __init__ (self, QRunnable)
- bool autoDelete (self)
- run (self)
- setAutoDelete (self, bool)

## Detailed Description

The QRunnable class is the base class for all runnable objects.

The QRunnable class is an interface for representing a task or piece of code that needs to be executed, represented by your reimplementation of the run() function.

You can use QThreadPool to execute your code in a separate thread. QThreadPool deletes the QRunnable automatically if autoDelete() returns true (the default). Use setAutoDelete() to change the auto-deletion flag.

QThreadPool supports executing the same QRunnable more than once by calling QThreadPool.tryStart(this) from within the run() function. If autoDelete is enabled the QRunnable will be deleted when the last thread exits the run function. Calling QThreadPool.start() multiple times with the same QRunnable when autoDelete is enabled creates a race condition and is not recommended.

See also QThreadPool.

## Method Documentation

### QRunnable.__init__ (self)

Constructs a QRunnable. Auto-deletion is enabled by default.

See also autoDelete() and setAutoDelete().

### QRunnable.__init__ (self, QRunnable)

### bool QRunnable.autoDelete (self)

Returns true is auto-deletion is enabled; false otherwise.

If auto-deletion is enabled, QThreadPool will automatically delete this runnable after calling run(); otherwise, ownership remains with the application programmer.

See also setAutoDelete() and QThreadPool.

### QRunnable.run (self)

This method is abstract and should be reimplemented in any sub-class.

Implement this pure virtual function in your subclass.

### QRunnable.setAutoDelete (self, bool)

Enables auto-deletion if autoDelete is true; otherwise auto-deletion is disabled.

If auto-deletion is enabled, QThreadPool will automatically delete this runnable after calling run(); otherwise, ownership remains with the application programmer.

Note that this flag must be set before calling QThreadPool.start(). Calling this function after QThreadPool.start() results in undefined behavior.

See also autoDelete() and QThreadPool.